UNIT WRBBS_T1;

{
**************************************************************************
**************************************************************************

This file is for use by thrid party developers who wish to write utilities
for WR-BBS.  You do not need this file for operation of WR-BBS.  If you do
not have a need for it, you can safely delete this file.

**************************************************************************
**************************************************************************
}

{ Compiled program WR-BBS is Copyright (C) 1993 by Wilson A. Rogers }

INTERFACE

{   These TYPE declarations are public -  other WR-BBS units use them   }

{

Although the WR-BBS program is copyrighted, the TYPE declarations for
most of the files used by WR-BBS are being published for use by third
party developers who may wish to write utilities that directly access
the WR-BBS database files.

DEVELOPERS:

When designing a utility for WR-BBS,  never change the following data
fields, as they are indexed by the W-TREE Database Manager, or relate
directly to DOS filenames:

User database:    FirstName, LastName
Files database:   FileName

Everything else is pretty much fair game - just be sensible.

}


USES
    DOS;

TYPE    { Record TYPE Declaration }
{------------------------------------------------------------------------}
    COS_Structure                        = RECORD
        AsciiXfer,
            OverWrite,
        SignalSysOp                      : ARRAY [ 65..90 ] OF BOOLEAN;
        TimeLimit                        : ARRAY [ 65..90 ] OF WORD;
    END;    { RECORD TYPE definition for COS_Structure }
{------------------------------------------------------------------------}
    { DataBaseFlag is used by WR-BBS to determine state of database }
    DataBaseFlag                         = RECORD
        DataBaseOpen                     : BOOLEAN;
    END;    { RECORD TYPE Declaration for DataBaseFlag }
{------------------------------------------------------------------------}
    DoorRecord                           = RECORD
        DoorActive                       : BOOLEAN;
        DoorCOS                          : ARRAY [ 65..90 ] OF BOOLEAN;
    END;    { RECORD TYPE declaration for DoorRecord }
{------------------------------------------------------------------------}
    EventRecord                           = RECORD
        EventDay, EventHour,
            EventMinute                   : BYTE;
        EventRunString                    : STRING [ 128 ];
        EventSuspended,
            EventRanToday                 : BOOLEAN;
        LastExecuted                      : STRING [ 14 ];
    END;    { RECORD TYPE declaration for EventRecord }
{------------------------------------------------------------------------}
    FileAreaRecord                        = RECORD
        NameOfArea, PathOfArea            : STRING [ 64 ];
        CosForThisArea                    : ARRAY [ 65..90 ] OF BOOLEAN;
        AreaIsActive                      : BOOLEAN;
    END;    { RECORD TYPE declaration for FileAreaRecord }
{------------------------------------------------------------------------}
    { LibraryRecord is for File Library (File descriptions) }
    LibraryRecord                        = RECORD
        FileArea                         : BYTE;
        FileName                         : STRING [ 12 ];
        Description                      : ARRAY [ 1..8 ] OF STRING [ 64 ];
        LibFileSize, TotalDownloads      : LongInt;
        FileAdded, FileCreated,
            LastDownload                 : DateTime;
        UploaderName                     : STRING [ 32 ];
        Password                         : STRING [ 16 ];
        ForSysOpOnly, NotOnDisk,
            DeletedRecord                : BOOLEAN;
    END;    { RECORD TYPE Declaration for LibraryRecord }
{------------------------------------------------------------------------}
    { MsgDataRecord is for Mail System }
    MsgDataRecord                        = RECORD
        RecipientName, SenderName        : STRING [ 32 ];
        Subject                          : STRING [ 64 ];
        Deleted, Forwarded, Private,
            Received                     : BOOLEAN;
        SentYear, SentMonth, SentDay,
            SentHour, SentMinute,
            ReceivedYear, ReceivedMonth,
            ReceivedDay, ReceivedHour,
            ReceivedMinute, TimesRead    : WORD;
        MessageLines                     : BYTE;
        MessageFileName                  : STRING [ 80 ];
        MessageNumber                    : LongInt;
    END;    { RECORD TYPE Declaration for MsgDataRecord }
{------------------------------------------------------------------------}
    { PegRecord contains volatile data that changes for each call }
    PegRecord                            = RECORD
        LastCallerName, LastCall,
            LastEvent                    : STRING [ 32 ];
        CallsToday, DayIndex,
            MessageIndex, NewMessages,
            TotalCalls, Uploads          : WORD;
        EventHistory                     : ARRAY [ 1..16 ] OF EventRecord;
    END;    { RECORD TYPE Declaration for PegRecord }
{------------------------------------------------------------------------}
    ProtocolRecord                        = RECORD
        ProtocolName                      : STRING [ 48 ];
        BatchMode, Configured             : BOOLEAN;
        KeyWord                           : STRING [ 32 ];
        CosPermitted                      : ARRAY [ 65..90 ] OF BOOLEAN;
    END;    { RECORD TYPE Declaration for ProtocolRecord }
{------------------------------------------------------------------------}
    { Screen is an ARRAY of WORDs used to store screen images }
    Screen                                = ARRAY [ 0..1999 ] OF WORD;
    DefaultScreenArray                    = ARRAY [ 0..1999 ] OF WORD;
{------------------------------------------------------------------------}
    UserRecord                            = RECORD
        FirstName, LastName, PassWord     : STRING [ 16 ];
        AddressOne, AddressTwo            : STRING [ 32 ];
        City, Country                     : STRING [ 24 ];
        State                             : STRING [ 2 ];
        DataPhone, VoicePhone             : STRING [ 16 ];
        ZipCode                           : STRING [ 15 ];
        FirstYear, FirstMonth,
            FirstDay, FirstDayName,
            FirstHour,
            FirstMinute, LastYear,
            LastMonth, LastDay,
            LastDayName,
            LastHour, LastMinute,
            FileYear, FileMonth,
            FileDay, FileDayName,
            MessageYear,
            MessageMonth,MessageDay,
            MessageDayName,
            ExpireYear, ExpireMonth,
            ExpireDay,
            MinutesRemaining,
            Downloads,
            TotalCalls, Uploads           : WORD;
        HighMessageRead                   : ARRAY [ 1..32 ] OF WORD;
        ColorEnabled, DeletedRecord,
            LockedOut, MasterSysOp,
            NewUser                       : BOOLEAN;
        DownloadBytes, UploadBytes        : LongInt;
        ClassOfService                    : CHAR;
    END;    { Record TYPE declaration for UserRecord }
{------------------------------------------------------------------------}
    UserIndexRecord                       = RECORD
        NameKey                           : STRING [ 33 ];
        RecordLocation                    : LONGINT;
    END;    { Record TYPE declaration for UserIndexRecord }


IMPLEMENTATION
    { There is no implementation - this UNIT is just for TYPEs }
END.
